/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2009 Jaroslav Tulach
 */
package cz.xelfi.quoridor;

import cz.xelfi.quoridor.Player.Direction;
import java.io.IOException;
import java.io.StringWriter;

/** Basic tests in simple configuration.
 *
 * @author Jaroslav Tulach
 */
public class SerializeTest extends BoardCase {
    public SerializeTest (String testName) {
        super (testName);
    }

    @Override
    protected Board move(Board b, int player, Direction... where) throws IllegalPositionException {
        try {
            Board read = reread(b);
            return read.move(read.getPlayers().get(player), where);
        } catch (IOException ex) {
            throw new IllegalStateException(ex);
        }
    }
    protected Board fence(Board b, int player, char x, int y, Fence.Orientation orie)
    throws IllegalPositionException {
        try {
            Board read = reread(b);
            return read.fence(read.getPlayers().get(player), x, y, orie);
        } catch (IOException ex) {
            throw new IllegalStateException(ex);
        }
    }

    @Override
    protected Board apply(Board b, Move move) throws IllegalPositionException {
        try {
            Board read = reread(b);
            return read.apply(move);
        } catch (IOException ex) {
            throw new IllegalStateException(ex);
        }
    }

    private Board reread(Board b) throws IOException, IllegalPositionException {
        StringWriter w = new StringWriter();
        b.write(w);
        w.close();
        return picture2board(w.toString());
        //return Board.valueOf(w.toString());
    }

}
